package collections;

/**
 * <p>Title: Collections</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: Suplec</p>
 * @author Claude Bocage
 * @version 1.0
 */

/*+Exemples/exemple3.java*/
public class Exemple3 {
  public Exemple3() {
  }
  public static <T> void afficher(Liste<T> l) {
    for(Curseur<T> c = l.debut(); c != null; c = l.suivant(c)) {
      System.out.print(l.element(c) + " ");
    }
    System.out.println("");
  }

  public static <T> void permutter(Liste<T> l) {
    Curseur<T> c1 = l.debut();
    if (c1 == null) return;
    Curseur<T> c2 = l.suivant(c1);

    while (c1 != null && c2 != null) {
      T e1 = l.element(c1);
      T e2 = l.element(c2);
      l.remplacer(c1,e2);
      l.remplacer(c2,e1);
      c1 = l.suivant(c2);
      if (c1 != null) c2 = l.suivant(c1);
    }
  }

  public static void main(String[] args) {
    Liste<Integer> l1 = new ListeIterTableau<Integer>();
    Liste<Integer> l2 = new ListeIterChainee<Integer>();
    Liste<Integer> l3 = new ListeRecTableau<Integer>();
    Liste<Integer> l4 = new ListeRecChainee<Integer>();

    for (int i = 0; i < 9; i++) {
      l1.insererApres(null, new Integer(i));
      l2.insererApres(null, new Integer(i));
      l3.insererApres(null, new Integer(i));
      l4.insererApres(null, new Integer(i));
    }
    permutter(l1);
    permutter(l2);
    permutter(l3);
    permutter(l4);
    afficher(l1);
    afficher(l2);
    afficher(l3);
    afficher(l4);
  }
}
/*-*/