package collections;

/**
 * <p>Title: Collections</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: Suplec</p>
 * @author Claude Bocage
 * @version 1.0
 */
/*+Exemples/exemple4.java*/
public class Exemple4 {
  public Exemple4() {
  }
  public static <T> void afficher(Liste<T> l) {
    for(Curseur<T> c = l.debut(); c != null; c = l.suivant(c)) {
      System.out.print(l.element(c) + " ");
    }
    System.out.println("");
  }

  public static <T extends Comparable<T>> void inserer(Liste<T> l, T e) {
    Curseur<T> avant = null;
    Curseur<T> apres = l.debut();

    while (apres != null && e.compareTo(l.element(apres)) > 0) {
      avant = apres;
      apres = l.suivant(apres);
    }
    l.insererApres(avant,e);
  }

  public static void main(String[] args) {
    Liste<Integer> l1 = new ListeIterTableau<Integer>();
    Liste<Integer> l2 = new ListeIterChainee<Integer>();
    Liste<Integer> l3 = new ListeRecTableau<Integer>();
    Liste<Integer> l4 = new ListeRecChainee<Integer>();

    for (int i = 100; i > 0; i-=10) {
      l1.insererApres(null, new Integer(i));
      l2.insererApres(null, new Integer(i));
      l3.insererApres(null, new Integer(i));
      l4.insererApres(null, new Integer(i));
    }
    for (int i = 5; i < 110; i+=10) {
      inserer(l1, new Integer(i));
      inserer(l2, new Integer(i));
      inserer(l3, new Integer(i));
      inserer(l4, new Integer(i));
    }
    afficher(l1);
    afficher(l2);
    afficher(l3);
    afficher(l4);
  }
}
/*-*/
