package collections;

/*+FileChainee/file1.java*/
public class FileChainee<T> extends File<T> {
  private Maillon<T> premier_;
  private Maillon<T> dernier_;

  public FileChainee() {
    premier_ = null;
    dernier_ = null;
  }

  public void ajouter(T e) {
    Maillon<T> nouveau = new Maillon<T>(e, null);
    if (dernier_ == null)
      premier_ = nouveau;
    else
      dernier_.suivant = nouveau;
    dernier_ = nouveau;
  }

  public void enlever() {
    prerequis(premier_ != null);
    premier_ = premier_.suivant;
    if (premier_ == null) dernier_ = null;
  }

  public T premier() {
    prerequis(premier_ != null);
    return premier_.element;
  }
/*-*/
/*+FileChainee/file2.java*/

  public boolean estvide() {
    return premier_ == null;
  }
  private class Maillon<T> {
    public T element;
    public Maillon<T> suivant;

    public Maillon(T e, Maillon<T> s) {
      element = e;
      suivant = s;
    }
  }
}
/*-*/