/**
 * <p>Titre : File par tableau</p>
 * <p>Description : Implmentation d'une classe File par tableau gr
 * circulairement</p>
 * <p>Copyright : Copyright Suplec(c) 2002</p>
 * <p>Socit : Suplec</p>
 * @author non attribu
 * @version 1.0
 */
package collections;

/*+FileTableau/file1.java*/
public class FileTableau<T> extends File<T> {
  private T[] tab_;
  private int premier_, dernier_, longueur_;
  private final int DELTA = 10;

  @SuppressWarnings("unchecked")
  private T[] creerTableau(int taille) {
    return (T[])new Object[taille];
  }
  
  public FileTableau() {
    tab_ = creerTableau(DELTA);
    premier_  = 0;
    dernier_ = DELTA - 1;
    longueur_ = 0;
  }

  // Mthode ajouter avec agrandissement ventuel du tableau
/*-*/
/*+FileTableau/file2.java*/
  public void ajouter(T e) {
    if (longueur_ >= tab_.length) {
      T[] nouveau = creerTableau(tab_.length + DELTA);
      for (int itab = premier_, inouveau = 0;
           inouveau < longueur_; itab++, inouveau++) {
        nouveau[inouveau] = tab_[itab % tab_.length];
      }
      premier_ = 0;
      dernier_ = longueur_ - 1;
      tab_ = nouveau;
    }
    dernier_ = (dernier_ + 1) % tab_.length;
    tab_[dernier_] = e;
    longueur_++;
  }

  public void enlever() {
    prerequis(!estvide());
    premier_ = (premier_ + 1) % tab_.length;
    longueur_--;
  }

  public T premier() {
    prerequis(!estvide());
    return tab_[premier_];
  }

  public boolean estvide() {
    return longueur_ == 0;
  }
  /*-*/
  public static void main(String [] args) {
    FileTableau<String> f = new FileTableau<String>();
    f.ajouter("Je");
    f.ajouter("fais");
    f.ajouter("la");
    f.ajouter("queue");
    while (!f.estvide()) {
      System.out.println(f.premier());
      f.enlever();
    }
  }
  /*+FileTableau/file2.java*/
}
/*-*/
