package collections;
import java.util.HashMap;
import java.io.*;
import java.util.HashMap;
import java.util.StringTokenizer;


/**
 * <p>Title: Collections</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: Suplec</p>
 * @author Claude Bocage
 * @version 1.0
 */

/*+GrapheNonOriente/graphe.java*/
public abstract class GrapheNonOriente {
  public abstract Sommet ajouterSommet();
  public abstract Arete ajouterArete(Sommet s1, Sommet s2, Number cout);
  public abstract void valuerArete(Arete a, Number valeur);
  public abstract void supprimerSommet(Sommet s);
  public abstract void supprimerArete(Arete a);
  public abstract boolean areteExiste(Sommet s1, Sommet s2);
  public abstract int degre(Sommet s);
  public abstract int nombreDeSommets();
  public abstract Curseur<Arete> premiereArete(Sommet s);
  public abstract Curseur<Arete> areteSuivante(Curseur<Arete> c);
  public abstract Arete arete(Curseur<Arete> c);
  public abstract Curseur<Sommet> premierSommet();
  public abstract Curseur<Sommet> sommetSuivant(Curseur<Sommet> c);
  public abstract Sommet sommet(Curseur<Sommet> c);
  /*P+*/
  protected void prerequis(boolean b) {
    if (!b) {
      throw new Error("Prrequis non valide dans " + getClass().getName());
    }
  }

  public Object clone() {
    GrapheNonOriente copie;
    try {
      copie = (GrapheNonOriente) getClass().newInstance();
    } catch (Exception e) {
      throw new Error("Exception");
    }
    for(Curseur<Sommet> c = premierSommet(); c != null; c = sommetSuivant(c)) {
      Sommet s = sommet(c);
      Sommet sc = copie.ajouterSommet();
      sc.donneesUtilisateur = s.donneesUtilisateur;
      s.donneesUtilisateur = new DonneesClonage(sc, s.donneesUtilisateur);
    }
    for(Curseur<Sommet> c = premierSommet(); c != null; c = sommetSuivant(c)) {
      Sommet s = sommet(c);
      for (Curseur<Arete> ca = premiereArete(s); ca != null; ca = areteSuivante(ca)) {
        Arete a = arete(ca);
        Sommet s1 = a.sommet1();
        Sommet s2 = a.sommet2();
        if (s1 == s && ((DonneesClonage)s2.donneesUtilisateur).aretesCopiees)
          continue;
        if (s2 == s && ((DonneesClonage)s1.donneesUtilisateur).aretesCopiees)
          continue;
        Arete ac = copie.ajouterArete(((DonneesClonage)s1.donneesUtilisateur).sommetClone,((DonneesClonage)s2.donneesUtilisateur).sommetClone, a.cout());
      }
      ((DonneesClonage)s.donneesUtilisateur).aretesCopiees = true;
    }
    for(Curseur<Sommet> c = premierSommet(); c != null; c = sommetSuivant(c)) {
      Sommet s = sommet(c);
      s.donneesUtilisateur = ((DonneesClonage)s.donneesUtilisateur).donneesUtilisateur;
    }
    return copie;
  }

  public HashMap<String, Sommet> lire(String nomFichier) throws java.io.FileNotFoundException, java.io.IOException{
    FileReader flux = new FileReader(nomFichier);
    BufferedReader buf = new BufferedReader(flux);
    String line = null;
    HashMap<String, Sommet> sommets = new HashMap<String, Sommet>();
    Sommet sd, sa;

    while ((line = buf.readLine()) != null) {
      // on ignore les lignes vides
      if (line.compareTo("") == 0)  continue;
      // ainsi que celles qui dbutent par '#' (commentaires)
      if (line.charAt(0) == '#')  continue;
      StringTokenizer toks = new StringTokenizer(line, " [,]");
      String depart = toks.nextToken();
      String arrivee = toks.nextToken();
      int cout = Integer.decode(toks.nextToken()).intValue();
      if (sommets.containsKey(depart))
        sd = (Sommet)sommets.get(depart);
      else {
        sd = ajouterSommet();
        sd.donneesUtilisateur = new DonneesSommet(depart);
        sommets.put(depart,sd);
      }
      if (sommets.containsKey(arrivee))
        sa = (Sommet)sommets.get(arrivee);
      else {
        sa = ajouterSommet();
        sa.donneesUtilisateur = new DonneesSommet(arrivee);
        sommets.put(arrivee,sa);
      }
      Arete arete = ajouterArete(sd,sa, new Integer(cout));
      arete.donneesUtilisateur = "(" + sd.donneesUtilisateur + "," + sa.donneesUtilisateur + cout + ")";
    }
    return sommets;
  }
  private class DonneesClonage {
    public Object donneesUtilisateur;
    public Sommet sommetClone;
    public boolean aretesCopiees;

    public DonneesClonage(Sommet s, Object donnees) {
      sommetClone = s;
      donneesUtilisateur = donnees;
      aretesCopiees = false;
    }
  }
/*P-*/
}
/*-*/
