/* -*-Java-*-
 * ###################################################################
 * 
 *  FILE: "IterateurListe.java"
 *                                    created: 2004-03-11 15:32:31 
 *                                last update: 2008-02-22 17:04:10 
 *  Author: Frdric Boulanger
 *  E-mail: Frederic.Boulanger@supelec.fr
 *    mail: Suplec - Service Informatique
 *          3 rue Joliot-Curie, 91192 Gif-sur-Yvette cedex, France
 *     www: http://wwwsi.supelec.fr/fb/
 *  
 *  Description: 
 *  Exemple de dfinition d'un itrateur direct sur des listes.
 *  
 *  History
 * 
 *  modified   by  rev reason
 *  ---------- --- --- -----------
 *  2004-03-11 FBO 1.0 original
 * ###################################################################
 */
package collections;

/**
 * Itrateur direct sur les listes.
 * Implmentation "simplette" utilisant les curseurs, qui sert de
 * lien avec les itrateurs de la bibliothque standard de Java
 * (dans laquelle la notion de curseur n'est pas explicite).
 */
/*+Liste/iterateur.java*/
public class IterateurListe<T> {
  /** Position de l'lment suivant du parcours. */
  private Curseur<T> suivant_;
  /** Liste parcourue. */
  private Liste<T> liste_;
  
  /** Cre un parcours direct de la liste <code>l</code>. */
  public IterateurListe(Liste<T> l) {
    liste_ = l;
    suivant_ = l.debut();
  }
  
  /** Indique s'il y a encore des lments  parcourir. */
  public boolean encore() {
    return (suivant_ != null);
  }
  
  /** Rend l'lment suivant, ou null s'il n'y en a pas. */
  public T suivant() {
    if (suivant_ == null) {
      return null;
    } else {
      T o = liste_.element(suivant_);
      suivant_ = liste_.suivant(suivant_);
      return o;
    }
  }  
}
/*-*/
