/* -*-Java-*-
 * ###################################################################
 *
 *  FILE: "Liste.java"
 *                                    created: 2003-02-10 10:51:32
 *                                last update: 2008-02-22 17:04:04
 *  Author: Frdric Boulanger
 *  E-mail: Frederic.Boulanger@supelec.fr
 *    mail: Suplec - Service Informatique
 *          3 rue Joliot-Curie, F-91192 Gif-sur-Yvette cedex
 *     www: http://wwwsi.supelec.fr/fb/
 *
 *  Description:
 *  Classe abstraite dclarant les oprations sur les curseurs
 *  communues  toutes les listes.
 *
 *  History
 *
 *  modified   by  rev reason
 *  ---------- --- --- -----------
 *  2003-02-10 FBO 1.0 original
 * ###################################################################
 */
package collections;

/** Liste utilisable uniquement  partir de curseurs. */
/*+Liste/classe.java*/
public abstract class Liste<T> {
  // Oprations sur les curseurs.
  //   1) Parcours et accs aux lments

  /** Rend un curseur sur la tte de la liste. */
  public abstract Curseur<T> debut();

  /** Rend un curseur sur la position suivant <code>c</code> dans la liste. */
  public abstract Curseur<T> suivant(Curseur<T> c);

  /** Rend l'lment se trouvant  la position indique par <code>c</code>. */
  public abstract T element(Curseur<T> c);

  //   2) Modifications laissant le curseur valide.

  /** Remplace l'lment situ en <code>c</code> par <code>e</code>. */
  public abstract void remplacer(Curseur<T> c, T o);

  /** Supprime l'lment l'lment situ aprs <code>c</code>. */
  public abstract void supprimerSuivant(Curseur<T> c);

  /** Insre l'lment <code>e</code>  la position qui suit <code>c</code>c. */
  public abstract void insererApres(Curseur<T> c, T o);
  /** Rend une reprsentation textuelle de la liste. */
/*P+*/
  public String toString() {
    StringBuffer buf = new StringBuffer();
    buf.append("(");
    Curseur<T> c = debut();
    while (c != null) {
      buf.append(element(c).toString());
      c = suivant(c);
      if (c != null) {
        buf.append(",");
      }
    }
    buf.append(")");
    return buf.toString();
  }

  /** Provoque une erreur si un prrequis n'est pas valide. */
  protected void prerequis(boolean b) {
    if (!b) {
      throw new Error("Prrequis non valide dans " + getClass().getName());
    }
  }
  protected abstract Liste<T> makeInstance();
/*P-*/
}
/*-*/
