package collections;

public class TestArbre {

  public TestArbre() {
  }

  public static void main(String[] args) throws java.lang.
      IllegalAccessException, java.lang.InstantiationException {

    Arbre a;

    a = arbreAlatoire(10);
    testAxiome1("Arbre");
    testAxiome2("Arbre");
    testAxiome3("Arbre");
    testAxiome4("Arbre");
    testAxiome5("Arbre");
    testAxiome6("Arbre");
    testAxiome7("Arbre");
    testParcours("Arbre");
    testRemplacer("Arbre");
    testAjouterFilsGauche("Arbre");
    testAjouterFilsDroit("Arbre");
  }

  public static Arbre<String> arbreAlatoire(int nbNoeuds) {
    if (nbNoeuds == 0) {
      return new Arbre<String>();
    }
    int noeudsAGauche = (int) ( (nbNoeuds - 1) * java.lang.Math.random());
    int noeudsADroite = nbNoeuds - 1 - noeudsAGauche;
    String e = java.lang.Math.random() + "";
    return new Arbre<String>(arbreAlatoire(noeudsAGauche), e,
                             arbreAlatoire(noeudsADroite));
  }

  public static void pmess(String m1, String m2) {
    System.out.println(m1 + " : " + m2);
  }

//      estVide(arbreVide) = vrai
  static void testAxiome1(String message) throws java.lang.
      IllegalAccessException, java.lang.InstantiationException {
    Arbre<String> vide = new Arbre<String>();
    if (vide.estvide()) {
      pmess(message, "axiome 1 vrifi");
    }
    else {
      pmess(message, "axiome 1 non vrifi");
    }
  }

//      estVide(construire(g,e,d)) = faux
  static void testAxiome2(String message) throws java.lang.IllegalAccessException,
                                                 java.lang.InstantiationException {
    Arbre<String> a, g, d;
    String e = java.lang.Math.random() + "";
    boolean ok = true;
    g = new Arbre<String>();
    d = new Arbre<String>();
    a = new Arbre<String>(g, e, d);
    if (a.estvide()) {
      pmess(message, "axiome 2 non vrifi avec g et d vides");
      ok = false;
    }
    g = new Arbre<String>();
    d = arbreAlatoire(10);
    a = new Arbre<String>(g, e, d);
    if (a.estvide()) {
      pmess(message, "axiome 2 non vrifi avec g vide et d non vide");
      ok = false;
    }
    d = new Arbre<String>();
    g = arbreAlatoire(10);
    a = new Arbre<String>(g, e, d);
    if (a.estvide()) {
      pmess(message, "axiome 2 non vrifi avec g non vide et d  vide");
      ok = false;
    }
    g = arbreAlatoire(10);
    d = arbreAlatoire(10);
    a = new Arbre<String>(g, e, d);
    if (a.estvide()) {
      pmess(message, "axiome 2 non vrifi avec g et d non vides");
      ok = false;
    }
    if (ok) {
      pmess(message, "axiome 2 vrifi");
    }
  }

//      racine(construire(g,e,d)) = e
  static void testAxiome3(String message) throws java.lang.IllegalAccessException,
                                                 java.lang.InstantiationException {
    Arbre<String> a, g, d;
    String e = java.lang.Math.random() + "";
    boolean ok = true;
    g = new Arbre<String>();
    d = new Arbre<String>();
    a = new Arbre<String>(g, e, d);
    if (a.racine() != e) {
      pmess(message, "axiome 3 non vrifi avec g et d vides");
      ok = false;
    }
    g = new Arbre<String>();
    d = arbreAlatoire(10);
    a = new Arbre<String>(g, e, d);
    if (a.racine() != e) {
      pmess(message, "axiome 3 non vrifi avec g vide et d non vide");
      ok = false;
    }
    d = new Arbre<String>();
    g = arbreAlatoire(10);
    a = new Arbre<String>(g, e, d);
    if (a.racine() != e) {
      pmess(message, "axiome 3 non vrifi avec g non vide et d  vide");
      ok = false;
    }
    g = arbreAlatoire(10);
    d = arbreAlatoire(10);
    a = new Arbre<String>(g, e, d);
    if (a.racine() != e) {
      pmess(message, "axiome 3 non vrifi avec g et d non vides");
      ok = false;
    }
    if (ok) {
      pmess(message, "axiome 3 vrifi");
    }
  }

//      filsGauche(arbreVide) = arbreVide
  static void testAxiome4(String message) throws java.lang.
      IllegalAccessException, java.lang.InstantiationException {
    Arbre<String> a = new Arbre<String>();
    Arbre<String> vide = new Arbre<String>();
    a = a.filsGauche();
    if (a.equals(vide)) {
      pmess(message, "axiome 4 vrifi");
    }
    else {
      pmess(message, "axiome 4 non verifi");
    }
  }

//      filsGauche(construire(g,e,d)) = g
  static void testAxiome5(String message) throws java.lang.
      IllegalAccessException, java.lang.InstantiationException {
    Arbre<String> a, g, d;
    String e = java.lang.Math.random() + "";
    boolean ok = true;
    g = new Arbre<String>();
    d = new Arbre<String>();
    a = new Arbre<String>(g.dupliquer(), e, d);
    a = a.filsGauche();
    if (!a.equals(g)) {
      pmess(message, "axiome 5 non vrifi avec g et d vides");
      ok = false;
    }
    g = new Arbre<String>();
    d = arbreAlatoire(10);
    a = new Arbre<String>(g.dupliquer(), e, d);
    a = a.filsGauche();
    if (!a.equals(g)) {
      pmess(message, "axiome 5 non vrifi avec g vide et d non vide");
      ok = false;
    }
    d = new Arbre<String>();
    g = arbreAlatoire(10);
    a = new Arbre<String>(g.dupliquer(), e, d);
    a = a.filsGauche();
    if (!a.equals(g)) {
      pmess(message, "axiome 5 non vrifi avec g non vide et d  vide");
      ok = false;
    }
    g = arbreAlatoire(10);
    d = arbreAlatoire(10);
    a = new Arbre<String>(g.dupliquer(), e, d);
    a = a.filsGauche();
    if (!a.equals(g)) {
      pmess(message, "axiome 5 non vrifi avec g et d non vides");
      ok = false;
    }
    if (ok) {
      pmess(message, "axiome 5 vrifi");
    }
  }

//      filsDroit(arbreVide) = arbreVide
  static void testAxiome6(String message) throws java.lang.
      IllegalAccessException, java.lang.InstantiationException {
    Arbre<String> a = new Arbre<String>();
    Arbre<String> vide = new Arbre<String>();
    a = a.filsDroit();
    if (a.equals(vide)) {
      pmess(message, "axiome 6 vrifi");
    }
    else {
      pmess(message, "axiome 6 non verifi");
    }
  }

//      filsDroit(construire(g,e,d)) = d
  static void testAxiome7(String message) throws java.lang.
      IllegalAccessException, java.lang.InstantiationException {
    Arbre<String> a, g, d;
    String e = java.lang.Math.random() + "";
    boolean ok = true;
    g = new Arbre<String>();
    d = new Arbre<String>();
    a = new Arbre<String>(g, e, d.dupliquer());
    a = a.filsDroit();
    if (!a.equals(d)) {
      pmess(message, "axiome 7 non vrifi avec g et d vides");
      ok = false;
    }
    g = new Arbre<String>();
    d = arbreAlatoire(10);
    a = new Arbre<String>(g, e, d.dupliquer());
    a = a.filsDroit();
    if (!a.equals(d)) {
      pmess(message, "axiome 7 non vrifi avec g vide et d non vide");
      ok = false;
    }
    d = new Arbre<String>();
    g = arbreAlatoire(10);
    a = new Arbre<String>(g, e, d.dupliquer());
    a = a.filsDroit();
    if (!a.equals(d)) {
      pmess(message, "axiome 7 non vrifi avec g non vide et d  vide");
      ok = false;
    }
    g = arbreAlatoire(10);
    d = arbreAlatoire(10);
    a = new Arbre<String>(g, e, d.dupliquer());
    a = a.filsDroit();
    if (!a.equals(d)) {
      pmess(message, "axiome 7 non vrifi avec g et d non vides");
      ok = false;
    }
    if (ok) {
      pmess(message, "axiome 7 vrifi");
    }
  }

// Test de parcours
  static void testParcours(String message) throws java.lang.
      IllegalAccessException, java.lang.InstantiationException {
    Arbre<String> a = arbreAlatoire(1000);
    Arbre<String> sa = a.dupliquer();
    if (testParcoursRec(a, sa, a.curseurRacine())) {
      pmess(message, "test de parcours correct");
    }
    else {
      pmess(message, "test de parcours echou");
    }
  }

  static <T> boolean testParcoursRec(Arbre<T> a, Arbre<T> sa, Curseur<T> c) {
    if (sa.estvide() && c == null) {
      return true;
    }
    if (sa.estvide() && c != null) {
      pmess("", "sa vide et c non null");
      return false;
    }
    if (!sa.estvide() && c == null) {
      pmess("", "sa non vide et c null");
      return false;
    }
    if (sa.racine() != a.element(c)) {
      pmess("", "pas mme racine" + sa.racine() + "," + a.element(c));
      return false;
    }
    Curseur<T> cg = a.versFilsGauche(c);
    Curseur<T> cd = a.versFilsDroit(c);
    Arbre<T> copie = sa.dupliquer();
    Arbre<T> fg = copie.filsGauche();
    Arbre<T> fd = copie.filsDroit();
    if (!testParcoursRec(a, fg, cg)) {
      pmess("", "erreur  gauche");
      return false;
    }
    if (!testParcoursRec(a, fd, cd)) {
      pmess("", "erreur  droite");
      return false;
    }
    return true;
  }

// Test mthode remplacer
  static void testRemplacer(String message) throws java.lang.
      IllegalAccessException, java.lang.InstantiationException {

    Arbre<String> a = arbreAlatoire(1000);
    if (testRemplacerRec(a, a.curseurRacine())) {
      pmess(message, "test mthode remplacer correct");
    }
    else {
      pmess(message, "test mthode remplacer chou");
    }
  }

  static boolean testRemplacerRec(Arbre<String> a, Curseur<String> c) {
    if (c == null) {
      return true;
    }
    String e = java.lang.Math.random() + "";
    Arbre<String> copie = a.dupliquer();
    a.remplacer(e, c);
    if (!comparerRemplacer(copie, a, copie.curseurRacine(), a.curseurRacine(),
                           c, e)) {
      return false;
    }
    if (!testRemplacerRec(a, a.versFilsGauche(c))) {
      return false;
    }
    if (!testRemplacerRec(a, a.versFilsDroit(c))) {
      return false;
    }
    return true;
  }

  static <T> boolean comparerRemplacer(Arbre<T> original, Arbre<T> modifie, 
                                       Curseur<T> corig, Curseur<T> cmodif, 
                                       Curseur<T> c, T e) {
    if (corig == null && cmodif == null) {
      return true;
    }
    if (corig == null && cmodif != null) {
      return false;
    }
    if (corig != null && cmodif == null) {
      return false;
    }
    if (!modifie.memePosition(cmodif, c) &&
        original.element(corig) != modifie.element(cmodif)) {
      return false;
    }
    if (modifie.memePosition(cmodif, c) && modifie.element(c) != e) {
      return false;
    }
    if (!comparerRemplacer(original, modifie, original.versFilsGauche(corig),
                           modifie.versFilsGauche(cmodif), c, e)) {
      return false;
    }
    if (!comparerRemplacer(original, modifie, original.versFilsDroit(corig),
                           modifie.versFilsDroit(cmodif), c, e)) {
      return false;
    }
    return true;
  }

  static void testAjouterFilsGauche(String message) throws java.lang.
      IllegalAccessException, java.lang.InstantiationException {

    Arbre<String> a = arbreAlatoire(1000);
    if (testAjouterFilsGaucheRec(a, a.curseurRacine())) {
      pmess(message, "test mthode ajouterFilsGauche correct");
    }
    else {
      pmess(message, "test mthode ajouterFilsGauche chou");
    }
  }

  static boolean testAjouterFilsGaucheRec(Arbre<String> a, Curseur<String> c) {
    if (c == null) {
      return true;
    }
    if (a.versFilsGauche(c) == null) {
      String e = java.lang.Math.random() + "";
      Arbre<String> copie = a.dupliquer();
      a.ajouterFilsGauche(e, c);
 //     pmess("ajouterFilsGauche","ajout");
      if (!comparerAjouterFg(copie, a, copie.curseurRacine(), a.curseurRacine(),
                             c, e)) {
        return false;
      }
      if (!testAjouterFilsGaucheRec(a, a.versFilsDroit(c))) {
        return false;
      }
      return true;
    }
    if (!testAjouterFilsGaucheRec(a, a.versFilsGauche(c))) {
      return false;
    }
    if (!testAjouterFilsGaucheRec(a, a.versFilsDroit(c))) {
      return false;
    }
    return true;
  }

  static <T> boolean comparerAjouterFg(Arbre<T> original, Arbre<T> modifie, 
                                       Curseur<T> corig, Curseur<T> cmodif,
                                       Curseur<T> c, T e) {
    if (cmodif == c) {
      Curseur<T> cfg = modifie.versFilsGauche(c);
      if (cfg == null) {
        pmess("comparerAjouterFg", "pas de fils gauche aprs ajout");
        return false;
      }
      if (modifie.element(cfg) != e) {
        pmess("comparerAjouterFg", "pas le bon lment aprs ajout");
       return false;
      }
      if (modifie.versFilsGauche(cfg) != null) {
        pmess("comparerAjouterFg", "le fils gauche ajout a un fils gauche");
        return false;
      }
      if (modifie.versFilsDroit(cfg) != null) {
        pmess("comparerAjouterFg", "le fils gauche ajout a un fils droit");
        return false;
      }
      if (original.versFilsGauche(corig) != null) {
        pmess("comparerAjouterFg", "l'original a un fils gauche");
       return false;
      }
      if (original.element(corig) != modifie.element(cmodif)) {
       return false;
     }
     return true;
   }
    else {
      if (corig == null && cmodif == null) {
        return true;
      }
      if (corig == null && cmodif != null) {
       return false;
      }
      if (corig != null && cmodif == null) {
        return false;
      }
    }
    if (original.element(corig) != modifie.element(cmodif)) {
      return false;
    }
    if (!comparerAjouterFg(original, modifie, original.versFilsGauche(corig),
                           modifie.versFilsGauche(cmodif), c, e)) {
      return false;
    }
    if (!comparerAjouterFg(original, modifie, original.versFilsDroit(corig),
                           modifie.versFilsDroit(cmodif), c, e)) {
      return false;
    }
    return true;
  }

  static void testAjouterFilsDroit(String message) throws java.lang.
      IllegalAccessException, java.lang.InstantiationException {

    Arbre<String> a = arbreAlatoire(1000);
    if (testAjouterFilsGaucheRec(a, a.curseurRacine())) {
      pmess(message, "test mthode ajouterFilsDroit correct");
    }
    else {
      pmess(message, "test mthode ajouterFilsDroit chou");
    }
  }

  static boolean testAjouterFilsDroitRec(Arbre<String> a, Curseur<String> c) {
    if (c == null) {
      return true;
    }
    if (a.versFilsDroit(c) == null) {
      String e = java.lang.Math.random() + "";
      Arbre<String> copie = a.dupliquer();
      a.ajouterFilsDroit(e, c);
 //     pmess("ajouterFilsGauche","ajout");
      if (!comparerAjouterFd(copie, a, copie.curseurRacine(), a.curseurRacine(),
                             c, e)) {
        return false;
      }
      if (!testAjouterFilsDroitRec(a, a.versFilsGauche(c))) {
        return false;
      }
      return true;
    }
    if (!testAjouterFilsDroitRec(a, a.versFilsGauche(c))) {
      return false;
    }
    if (!testAjouterFilsDroitRec(a, a.versFilsDroit(c))) {
      return false;
    }
    return true;
  }

  static <T> boolean comparerAjouterFd(Arbre<T> original, Arbre<T> modifie,
                                       Curseur<T> corig, Curseur<T> cmodif,
                                       Curseur<T> c, T e) {
    if (cmodif == c) {
      Curseur<T> cfd = modifie.versFilsDroit(c);
      if (cfd == null) {
        pmess("comparerAjouterFg", "pas de fils gauche aprs ajout");
        return false;
      }
      if (modifie.element(cfd) != e) {
        pmess("comparerAjouterFg", "pas le bon lment aprs ajout");
       return false;
      }
      if (modifie.versFilsGauche(cfd) != null) {
        pmess("comparerAjouterFg", "le fils gauche ajout a un fils gauche");
        return false;
      }
      if (modifie.versFilsDroit(cfd) != null) {
        pmess("comparerAjouterFg", "le fils gauche ajout a un fils droit");
        return false;
      }
      if (original.versFilsDroit(corig) != null) {
        pmess("comparerAjouterFg", "l'original a un fils gauche");
       return false;
      }
      if (original.element(corig) != modifie.element(cmodif)) {
       return false;
     }
     return true;
   }
    else {
      if (corig == null && cmodif == null) {
        return true;
      }
      if (corig == null && cmodif != null) {
       return false;
      }
      if (corig != null && cmodif == null) {
        return false;
      }
    }
    if (original.element(corig) != modifie.element(cmodif)) {
      return false;
    }
    if (!comparerAjouterFd(original, modifie, original.versFilsGauche(corig),
                           modifie.versFilsGauche(cmodif), c, e)) {
      return false;
    }
    if (!comparerAjouterFd(original, modifie, original.versFilsDroit(corig),
                           modifie.versFilsDroit(cmodif), c, e)) {
      return false;
    }
    return true;
  }

}
