package collections;

public class TestListeIter {

  public TestListeIter() {
  }

  public static void main(String[] args) throws java.lang.
      IllegalAccessException, java.lang.InstantiationException {

    ListeIterTableau<String> lt = new ListeIterTableau<String>();
    ListeIterChainee<String> lc = new ListeIterChainee<String>();

    listeAlatoire(lt, 10);
    listeAlatoire(lc, 10);
    testAxiome1(lt, "Liste itrative par tableau");
    testAxiome1(lc, "Liste itrative par chanages");
    testAxiome2(lt, "Liste itrative par tableau");
    testAxiome2(lc, "Liste itrative par chanages");
    testAxiome3(lt, "Liste itrative par tableau");
    testAxiome3(lc, "Liste itrative par chanages");
    testAxiome4(lt, "Liste itrative par tableau");
    testAxiome4(lc, "Liste itrative par chanages");
    testAxiome5(lt, "Liste itrative par tableau");
    testAxiome5(lc, "Liste itrative par chanages");
    testCurseur(lt, "Liste itrative par tableau");
    testCurseur(lc, "Liste itrative par chanages");
  }

  static void listeAlatoire(ListeIter<String> l, int taille) {
    l.vider();
    for (int i = 0; i < taille; i++) {
      l.inserer(1, java.lang.Math.random() + "");
    }
  }

//    insrer(insrer(l,p1,e1),p2,e2) = si p1 < p2 alors
//                                         insrer(insrer(l,p2-1,e2),p1,e1)
//                                       sinon
//                                         insrer(insrer(l,p2,e2),p1+1,e1)
//                                       fin si
  static void testAxiome1(ListeIter<String> l, String message) throws java.lang.
      IllegalAccessException, java.lang.InstantiationException {
    ListeIter<String> l2, l3;
    String e1 = java.lang.Math.random() + "";
    String e2 = java.lang.Math.random() + "";
    boolean ok = true;
    for (int p1 = 1; p1 < l.longueur() + 1; p1++) {
      for (int p2 = 1; p2 < l.longueur() + 2; p2++) {
        l2 = l.dupliquer();
        l3 = l.dupliquer();
        l2.inserer(p1, e1);
        l2.inserer(p2, e2);
        if (p1 < p2) {
          l3.inserer(p2 - 1, e2);
          l3.inserer(p1, e1);
        }
        else {
          l3.inserer(p2, e2);
          l3.inserer(p1 + 1, e1);
        }
        if (!l2.equals(l3)) {
          pmess(message, "axiome 1 non vrifi");
          ok = false;
        }
      }
    }
    if (ok) {
      pmess(message, "axiome 1 vrifi");
    }
  }

//     supprimer(insrer(l,p,e),p) = l
  static void testAxiome2(ListeIter<String> l, String message) throws java.lang.
      IllegalAccessException, java.lang.InstantiationException {
    String e1 = java.lang.Math.random() + "";
    boolean ok = true;
    ListeIter<String> l2;
    for (int p = 1; p < l.longueur() + 1; p++) {
      l2 = l.dupliquer();
      l2.inserer(p, e1);
      l2.supprimer(p);
      if (!l2.equals(l)) {
        pmess(message, "axiome 2 non vrifi");
        ok = false;
      }
    }
    if (ok) {
      pmess(message, "axiome 2 vrifi");
    }
  }

//     longueur(listevide) = 0
  static void testAxiome3(ListeIter<String> l, String message) throws java.lang.
      IllegalAccessException, java.lang.InstantiationException {
    ListeIter<String> l2;
    boolean ok = true;
    l2 = l.makeInstance();
    if (l2.longueur() != 0) {
      pmess(message, "axiome 3 non vrifi");
    }
    else {
      pmess(message, "axiome 3 vrifi");
    }
  }

  //     longueur(insrer(l,p,e)) = longueur(l+1)
  static void testAxiome4(ListeIter<String> l, String message) throws java.lang.
      IllegalAccessException, java.lang.InstantiationException {
    ListeIter<String> l2;
    boolean ok = true;
    String e1 = java.lang.Math.random() + "";
    for (int p = 1; p < l.longueur() + 1; p++) {
      l2 = l.dupliquer();
      l2.inserer(p, e1);
      if (l2.longueur() != l.longueur() + 1) {
        pmess(message, "axiome 4 non vrifi");
        ok = false;
      }
    }
    if (ok) {
      pmess(message, "axiome 4 vrifi");
    }
  }

  static void testAxiome5(ListeIter<String> l, String message) throws java.lang.
      IllegalAccessException, java.lang.InstantiationException {
    ListeIter<String> l2;
    boolean ok = true;
    String e1 = java.lang.Math.random() + "";
//     ime(insrer(l,p,e),p) = e
    for (int p = 1; p < l.longueur() + 1; p++) {
      l2 = l.dupliquer();
      l2.inserer(p, e1);
      if (l2.ieme(p) != e1) {
        pmess(message, "axiome 5 non vrifi");
        ok = false;
      }
    }
    if (ok) {
      pmess(message, "axiome 5 vrifi");
    }
  }

  static void testCurseur(ListeIter<String> l, String message) throws java.lang.
      IllegalAccessException, java.lang.InstantiationException {
    Curseur<String> c;
    boolean ok = true;

// Test de parcours de la liste
    c = l.debut();
    if (c == null) {
      pmess(message, "erreur parcours : le curseur de dbut vaut null");
      return;
    }
    for (int i = 1; i <= l.longueur(); i++) {
      String o = l.element(c);
      if (o != l.ieme(i)) {
        pmess(message, "erreur parcours avec curseur sur lment " + i);
        ok = false;
      }
      if (c == null) {
        pmess(message, "erreur parcours avec curseur sur lment " + i +
              " (pas de suivant)");
        return;
      }
      c = l.suivant(c);
    }
    if (c != null) {
      pmess(message,
            "erreur parcours avec curseur : le dernier lment a un suivant");
      ok = false;
    }
    if (ok) {
      pmess(message, "test parcours ok");
    }
// Test de remplacement
    ok = true;
    ListeIter<String> l1 = l.dupliquer();
    ListeIter<String> l2 = l.dupliquer();
    c = l1.debut();
    String e;
    for (int i = 1; i <= l.longueur(); i++) {
      e = java.lang.Math.random() + "";
      l1.remplacer(c, e);
      l2.supprimer(i);
      l2.inserer(i, e);
      if (!l1.equals(l2)) {
        pmess(message, "erreur remplacement en position " + i);
        l1.afficher();l2.afficher();
        ok = false;
        break;
      }
      c = l1.suivant(c);
    }
    if (ok) {
      pmess(message, "test remplacement ok");
    }
// Test de supprimerSuivant
    ok = true;
    for (int i = 1; i <= l.longueur(); i++) {
      l1 = l.dupliquer();
      l2 = l.dupliquer();
      c = curseurEn(l1, i);
      for (int j = i; j < l.longueur(); j++) {
        l1.supprimerSuivant(c);
        l2.supprimer(i + 1);
        if (!l1.equals(l2)) {
          pmess(message,
                "erreur supprimerSuivant en position " + i + "(" + j + ")");
          ok = false;
          break;
        }
      }
    }
    if (ok) {
      pmess(message, "test supprimerSuivant ok");
    }
// Test de insererApres
    ok = true;
    for (int i = 1; i <= l.longueur(); i++) {
      l1 = l.dupliquer();
      l2 = l.dupliquer();
      c = curseurEn(l1, i);
      e = java.lang.Math.random() + "";
      l1.insererApres(c, e);
      l2.inserer(i + 1, e);
      if (!l1.equals(l2)) {
        pmess(message, "erreur insererApres en position " + i);
        ok = false;
        break;
      }
    }
    if (ok) {
      pmess(message, "test insererApres ok");
    }
  }

  public static Curseur<String> curseurEn(Liste<String> l, int pos) {
    Curseur<String> c = l.debut();
    for (int i = 1; i != pos; i++) {
      c = l.suivant(c);
    }
    return c;
  }

  public static void pmess(String m1, String m2) {
    System.out.println(m1 + " : " + m2);
  }
}
