package collections;

public class TestListeRec {

  public TestListeRec() {
  }

  public static void main(String[] args) throws java.lang.
      IllegalAccessException, java.lang.InstantiationException {

    ListeRecTableau<String> lt = new ListeRecTableau<String>();
    ListeRecChainee<String> lc = new ListeRecChainee<String>();

    listeAlatoire(lt, 10);
    listeAlatoire(lc, 10);
    testAxiome1(lt, "Liste rcursive par tableau");
    testAxiome1(lc, "Liste rcursive par chanages");
    testAxiome2(lt, "Liste rcursive par tableau");
    testAxiome2(lc, "Liste rcursive par chanages");
    testAxiome3(lt, "Liste rcursive par tableau");
    testAxiome3(lc, "Liste rcursive par chanages");
    testAxiome4(lt, "Liste rcursive par tableau");
    testAxiome4(lc, "Liste rcursive par chanages");
    testCurseur(lt, "Liste rcursive par tableau");
    testCurseur(lc, "Liste rcursive par chanages");
  }

  static void listeAlatoire(ListeRec<String> l, int taille) {
    l.vider();
    for (int i = 0; i < taille; i++) {
      l.ajouterDebut(java.lang.Math.random() + "");
    }
  }

//    enleverPremier(ajouterDebut(l,e)) = l
  static void testAxiome1(ListeRec<String> l, String message) throws java.lang.
      IllegalAccessException, java.lang.InstantiationException {
    ListeRec<String> l1, l2;
    String e = java.lang.Math.random() + "";
    boolean ok = true;
    l1 = l.makeInstance();
    l2 = l1.dupliquer();
    l1.ajouterDebut(e);
    l1.enleverPremier();
    if (!l1.equals(l2)) {
      pmess(message, "erreur axiome 1 sur liste vide");
      ok = false;
    }
    l1 = l.dupliquer();
    l2 = l1.dupliquer();
    l1.ajouterDebut(e);
    l1.enleverPremier();
    if (!l1.equals(l2)) {
      pmess(message, "erreur axiome 1 sur liste non vide");
      ok = false;
   }
    if (ok) {
      pmess(message, "axiome 1 vrifi");
    }
  }

//     premier(ajouterDebut(l,e)) = e
  static void testAxiome2(ListeRec<String> l, String message) throws java.lang.
      IllegalAccessException, java.lang.InstantiationException {
    ListeRec<String> l1;
    String e = java.lang.Math.random() + "";
    boolean ok = true;
    l1 = l.makeInstance();
    l1.ajouterDebut(e);
    if (l1.premier() != e) {
      pmess(message, "erreur axiome 2 sur liste vide");
      ok = false;
    }
    l1 = l.dupliquer();
    l1.ajouterDebut(e);
    if (l1.premier() != e) {
      pmess(message, "erreur axiome 2 sur liste non vide");
      ok = false;
    }
    if (ok) {
      pmess(message, "axiome 2 vrifi");
    }
  }

//     estvide(listevide) = vrai
  static void testAxiome3(ListeRec<String> l, String message) throws java.lang.
      IllegalAccessException, java.lang.InstantiationException {
    ListeRec<String> l1;
    l1 = l.makeInstance();
    if (!l1.estvide()) {
      pmess(message, "erreur axiome 3");
    }
    else {
      pmess(message, "axiome 3 vrifi");
    }
  }

  //     estvide(ajouterPremier(l,e)) = faux
  static void testAxiome4(ListeRec<String> l, String message) throws java.lang.
      IllegalAccessException, java.lang.InstantiationException {
    ListeRec<String> l1;
    String e = java.lang.Math.random() + "";
    boolean ok = true;
    l1 = l.makeInstance();
    l1.ajouterDebut(e);
    if (l1.estvide() ) {
      pmess(message, "erreur axiome 4 sur liste vide");
      ok = false;
    }
    l1 = l.dupliquer();
    l1.ajouterDebut(e);
    if (l1.estvide()) {
      pmess(message, "erreur axiome 4 sur liste non vide");
      ok = false;
    }
    if (ok) {
      pmess(message, "axiome 4 vrifi");
    }
  }

  static void testCurseur(ListeRec<String> l, String message) throws java.lang.
      IllegalAccessException, java.lang.InstantiationException {
    Curseur<String> c;
    boolean ok = true;
    ListeRec<String> l1;

// Test de parcours de la liste
    l1 = l.dupliquer();
    c = l.debut();
    if (c == null) {
      pmess(message, "erreur parcours : le curseur de dbut vaut null");
      return;
    }
    int i = 1;
    while (!l1.estvide()) {
      String o = l.element(c);
      String o1 = l1.premier();
      if (o != o1) {
        pmess(message, "erreur parcours avec curseur sur lment " + i);
        ok = false;
      }
      if (c == null) {
        pmess(message, "erreur parcours avec curseur sur lment " + i +
              " (pas de suivant)");
        return;
      }
      c = l.suivant(c);
      l1.enleverPremier();
      i++;
    }
    if (c != null) {
      pmess(message,
            "erreur parcours avec curseur : le dernier lment a un suivant");
      ok = false;
    }
    if (ok) {
      pmess(message, "test parcours ok");
    }
// Test de remplacement
    ok = true;
    l1 = l.dupliquer();
    ListeIter<String> l2= dupRecIter(l1);
    Curseur<String> c1 = l1.debut();
    Curseur<String> c2 = l2.debut();
    String e;
    while (c1 != null) {
      e = java.lang.Math.random() + "";
      l1.remplacer(c1, e);
      l2.remplacer(c2, e);
      if (!eqRecIter(l1,l2)) {
        pmess(message, "erreur remplacement en position " + i);
        ok = false;
        break;
      }
      c1 = l1.suivant(c1);
      c2 = l2.suivant(c2);
    }
    if (ok) {
      pmess(message, "test remplacement ok");
    }
// Test de supprimerSuivant
    ok = true;
    ListeIter<String> l3 = dupRecIter(l);
    for (int k = 1; k <= l3.longueur(); k++) {
      l1 = l.dupliquer();
      l2 = dupRecIter(l);
      c1 = curseurEn(l1, k);
      c2 = curseurEn(l2, k);
      for (int j = k; l2.suivant(c2) != null; j++) {
        l1.supprimerSuivant(c1);
        l2.supprimerSuivant(c2);
        if (!eqRecIter(l1,l2)) {
          pmess(message,
                "erreur supprimerSuivant en position " + k + "(" + j + ")");
          ok = false;
          break;
        }
      }
    }
    if (ok) {
      pmess(message, "test supprimerSuivant ok");
    }
// Test de insererApres
    ok = true;
    for (int k = 1; k <= l3.longueur(); k++) {
      l1 = l.dupliquer();
      l2 = dupRecIter(l);
      c1 = curseurEn(l1, k);
      c2 = curseurEn(l2, k);
      e = java.lang.Math.random() + "";
      l1.insererApres(c1, e);
      l2.insererApres(c2, e);
      if (!eqRecIter(l1,l2)) {
        pmess(message, "erreur insererApres en position " + k);
        ok = false;
        break;
      }
    }
    if (ok) {
      pmess(message, "test insererApres ok");
    }
  }

  public static <T> Curseur<T> curseurEn(Liste<T> l, int pos) {
    Curseur<T> c = l.debut();
    for (int i = 1; i != pos; i++) {
      c = l.suivant(c);
    }
    return c;
  }

  public static void pmess(String m1, String m2) {
    System.out.println(m1 + " : " + m2);
  }

  public static ListeIter<String> dupRecIter(ListeRec<String> source) {
    ListeIter<String> dest = new ListeIterTableau<String>();
    Curseur<String> c = source.debut();
    int i = 1;
    while ( c!= null) {
      dest.inserer(i,source.element(c));
      i++;
      c = source.suivant(c);
    }
    return dest;
  }

  public static boolean eqRecIter(ListeRec<String> l1, ListeIter<String> l2) {
    Curseur<String> c1 = l1.debut();
    Curseur<String> c2 = l2.debut();
    while (c1 != null && c2 != null) {
      if (l1.element(c1) != l2.element(c2)) {
        return false;
      }
      c1 = l1.suivant(c1);
      c2 = l2.suivant(c2);
    }
    return (c1 == null) && (c2 == null);
  }
}
