package collections;

public class Traitements {
    public static void main(String[] args) {
        Foret<Integer> a = new Foret<Integer>(new Foret<Integer>(),1, new Foret<Integer>());
        Curseur<Integer> c = a.curseurRacine();
        a.ajouterFilsAine(4,c);
        a.ajouterFilsAine(3,c);
        a.ajouterFilsAine(2,c);
        c = a.versFilsAine(c);
        a.ajouterFilsAine(6,c);
        a.ajouterFilsAine(5,c);
        c = a.versFrereCadet(c);
        a.ajouterFilsAine(9,c);
        a.ajouterFilsAine(8,c);
        a.ajouterFilsAine(7,c);
        c = a.versFilsAine(c);
        c = a.versFrereCadet(c);
        a.ajouterFilsAine(11,c);
        a.ajouterFilsAine(10,c);
        System.out.println("Fort :        1       ");
        System.out.println("             / | \\      ");
        System.out.println("            /  |  \\      ");
        System.out.println("           /   |   \\     ");
        System.out.println("          /    |    \\     ");
        System.out.println("         2     3     4    ");
        System.out.println("        / \\   /|\\   ");
        System.out.println("       5   6 7 8 9  ");
        System.out.println("              / \\ ");
        System.out.println("             10  11");
        System.out.print("Parcours en pr-ordre : ");
        ParcoursForet.preordreRec(a, a.curseurRacine(), new Affichage<Integer>());
        System.out.println();
        System.out.print("Parcours en pr-ordre (autre mthode) : ");
        ParcoursForet.preordreIter(a, a.curseurRacine(), new Affichage<Integer>());
        System.out.println();
        System.out.print("Parcours en ordre : ");
        ParcoursForet.enordre(a, a.curseurRacine(), new Affichage<Integer>());
        System.out.println();
        System.out.print("Parcours en post-ordre : ");
        ParcoursForet.postordreRec(a, a.curseurRacine(), new Affichage<Integer>());
        System.out.println();
        System.out.print("Parcours en post-ordre (autre mthode) : ");
        ParcoursForet.postordreIter(a, a.curseurRacine(), new Affichage<Integer>());
        System.out.println();
        System.out.print("Parcours en largeur : ");
        ParcoursForet.largeur(a, a.curseurRacine(), new Affichage<Integer>());
        System.out.println();
/*+ParcoursForet/exempleSommer.java*/
  Sommer<Integer> sum = new Sommer<Integer>();
  ParcoursForet.preordreRec(a, a.curseurRacine(), sum);
  System.out.println("Somme des noeuds de l'arbre = " + sum.resultat());
/*-*/
    }
}

/*+ParcoursForet/Affichage.java*/
class Affichage<T> implements Traitement<T> {
    public void traiter(T o) {
        System.out.print(o + " ");
    }
}
/*-*/

/*+ParcoursForet/Sommer.java*/
class Sommer<T extends Number> implements Traitement<T> {
    private double somme_;
    public Sommer() {
        somme_ = 0.0;
    }
    public void traiter(T o) {
        somme_ += o.doubleValue();
    }
    public double resultat() {
        return somme_;
    }
}
/*-*/
